<?php

/*
Plugin Name:    Topsy Widgets
Version:        1.1.0
Plugin URI:     http://labs.topsy.com/widgets/wordpress
Author:         Topsy Labs
Author URI:     http://topsy.com/
Description:    Provides a Twitter retweet button powered by <a href="http://topsy.com/">Topsy</a>. 
Copyright:      Copyright 2009 by Topsy Labs. This software is distributed under the terms of the GNU GPL as defined in LICENSE.txt.
*/ 

global $TOPSY_VERSION;
$TOPSY_VERSION = '1.1.0';
global $topsy_cache_time_tb, $topsy_cache_time_udata, $topsy_conn_timeout, $topsy_debug;
$topsy_cache_time_tb = 300;
$topsy_cache_time_udata = 3600;
$topsy_conn_timeout = 10.0;
$topsy_debug = 0;


function topsy_init() {
    load_plugin_textdomain('topsy', PLUGINDIR . '/' . dirname(plugin_basename(__FILE__)) );
}

function shortcode_topsy_retweet_big() {
    return topsy_generate_retweet_button('big');
}
function shortcode_topsy_retweet_small() {
    return topsy_generate_retweet_button('small');
}

function topsy_action_admin_menu() {
    add_submenu_page('options-general.php', 'Topsy Options', 'Topsy Widgets', 9, 'topsy', 'topsy_settings_menu');
    if( !get_option('topsy_trackbacks_enabled') ) { topsy_settings_reset(); }
}

function topsy_activation() {
    add_option('topsy_trackbacks_enabled', 'off');
    add_option('topsy_trackbacks_infonly', 'off');
    add_option('topsy_rl_limit', '1');
    add_option('topsy_rl_remaining', '1');
    add_option('topsy_rl_reset', '1');
    add_option('topsy_linkify_hashtag', 'on');
    add_option('topsy_linkify_atuser', 'on');
    add_option('topsy_ignore_list', '');
    add_option('topsy_comment_type', 'trackback');
    $pages = array( 'home', 'page', 'post', 'category', 'archive' );
    foreach ($pages as $page) {
        add_option('topsy_button_' . $page . '_display',    'on');
        add_option('topsy_button_' . $page . '_position',   'before');
        add_option('topsy_button_' . $page . '_align',      'right');
        add_option('topsy_button_' . $page . '_style',      'big');
        add_option('topsy_button_' . $page . '_css',        'margin-left: 0.75em;');
    }
    add_option('topsy_add_button_to_rss', 'off');
    add_option('topsy_autonotify_enabled', 'on');
    add_option('topsy_smallbutton_order', $settings['topsy_smallbutton_order']);
    add_option('topsy_url_shortener', 'bitly');
    add_option('topsy_urlshortener_username', 'topsyplugin');
    add_option('topsy_urlshortener_authkey', 'R_0bb5fbe4ce1eb830679766704df41937');
    topsy_update_shortener_data();
}

function topsy_comment_exists($item) {
    global $post;
    foreach (get_comments("post_id=$post->ID") as $c) {
        if ($c->comment_author_url == $item->permalink_url) {
            return true;
        }
        if ($c->comment_author == $item->author->name && $c->comment_date == date('Y-m-d H:i:s', $item->date)) {
            return true;
        }
    }
    return false;
}

function topsy_eval_braces($data) {
    $data = $data[1];
    $num = preg_match_all("/\\$([-\w]+)/", $data, $vars);
    foreach ($vars[1] as $x) {
        global ${$x};
    }
    global $post;
    if ($post) {
        $post_title = $post->post_title;
        $post_author = $post->post_author;
    }
    if (preg_match("/\)-\>/", $data)) {
        $data = preg_replace("/\)-\>/", ')SPLIT->', $data);
        list($obj, $attr) = explode('SPLIT', $data);
        eval("\$obj = $obj;");
        eval("\$ret = \$obj$attr;");
        return $ret;
    }
    if (preg_match("/^\w+$/", $data)) {
        $data = "get_option('$data')";
    }
    eval("\$ret = $data;");
    return $ret;
}
function topsy_eval_data($str) {
    $str = preg_replace_callback("/\[([^\]]+)\]/", "topsy_eval_braces", $str);
    return $str;
}

function topsy_filter_the_content($content) {
    if( is_home()       && get_option('topsy_button_home_display')      == 'off') { return $content; }
    if( is_page()       && get_option('topsy_button_page_display')      == 'off') { return $content; }
    if( is_single()     && get_option('topsy_button_post_display')      == 'off') { return $content; }
    if( is_category()   && get_option('topsy_button_category_display')  == 'off')  { return $content; }
    if( is_archive()    && get_option('topsy_button_archive_display')   == 'off' && !is_category() ) { return $content; }

    $page = null;

    if ( is_home() ) { $page = 'home'; }
    if ( is_page() ) { $page = 'page'; }
    if ( is_single() ) { $page = 'post'; }
    if ( is_category() ) { $page = 'category'; }
    if ( is_archive() && !is_category() ) { $page = 'archive'; }

    $button = topsy_generate_retweet_button(get_option('topsy_button_' . $page . '_style'));

    switch ( get_option('topsy_button_' . $page . '_align') ) {
        case 'left':    { $align_css = 'float: left;'; break; }
        case 'right':   { $align_css = 'float: right;'; break; }
        default:        { $align_css = ''; break; }
    }
    $button = '<div class="topsy_widget_data" style="' . $align_css . get_option('topsy_button_'.$page.'_css') . '">' . $button . '</div>';

    switch ( get_option('topsy_button_' . $page . '_position') ) {
        case 'before':  { $content = $button . $content; break; }
        case 'after':   { $content = $content . $button; break; }
    }
    return "\n$content\n";
}

function topsy_filter_the_content_rss($content) {
    if (get_option('topsy_add_button_to_rss')) {
        return topsy_filter_the_content($content);
    }
    return $content;
}

function topsy_generate_retweet_button($size = 'small') {
    $hostname = 'button';
    if (isset($_GET['topsybeta']) && $_GET['topsybeta'] == 1) {
        $hostname = 'beta.button';
    }
    $url = htmlentities(get_permalink());
    global $post;
    $short_url = get_post_meta($post->ID, 'topsy_short_url', true);
    if ($short_url) $short_url = "&shorturl=$short_url";
    $nick = get_option('topsy_retweet_username');
    if ($nick) $nick = "&nick=$nick";
    $order = get_option('topsy_smallbutton_order');
    if ($order) $order = "&order=$order";

    return "<script type=\"text/javascript\" src=\"http://$hostname.topsy.com/widget/retweet-$size?url=$url$short_url$nick$order\"></script>";
}

function topsy_get_cache_time($url) {
    global $post;
    return intval(get_post_meta($post->ID, '_topsy_cache_timestamp', true), 10);
}

function topsy_get_plugin_comments($full = false) {
    global $wpdb;
    if ($full) {
        return $wpdb->get_results("SELECT * FROM $wpdb->comments WHERE comment_agent LIKE 'Topsy plugin for WordPress%'");
    } else {
        $comments = $wpdb->get_results("SELECT comment_ID FROM $wpdb->comments WHERE comment_agent LIKE 'Topsy plugin for WordPress%'", ARRAY_N);
        $comments = array_map(create_function('$i','return $i[0];'), $comments);
        return $comments;
    }
}

function topsy_get_ratelimit($check = 'percent') {
    $limit = get_option('topsy_rl_limit');
    $remaining = get_option('topsy_rl_remaining');
    $reset = get_option('topsy_rl_reset');
    if ($check = 'full') {
        return array(
            'limit' => $limit,
            'remaining' => $remaining,
            'reset' => $reset,
        );
    } elseif ($check == 'reset') {
        return $reset;
    } elseif ($check == 'remaining') {
        return $remaining;
    } elseif ($check == 'limit') {
        return $limit;
    } else {
        $percent = floor($remaining * 100 / $limit);
    }
}

function topsy_handle_single_trackback($item, $tb_url) {
    global $post, $wpdb;
    global $TOPSY_VERSION;
    if (topsy_comment_exists($item)) {
        return;
    }
    if (! isset($item->date) || $item->date < 1000000) {
        return;
    }
    $tweeter_username = $tweeter_realname = $item->author->name;
    $tweeter_url = $item->author->url;
    $tweet_url = $item->permalink_url;
    if (preg_match("/^https?:\/\/(?:[-\w]+\.)?twitter\.com\/(\w{1,15})/", $tweeter_url, $match)) {
        $tweeter_username = $match[1];
    }
    if (in_array(strtolower($tweeter_username), explode('|', strtolower(get_option('topsy_ignore_list'))))) {
        return;
    }
    $tweeter_on_topsy = $item->author->topsy_author_url;
    $tweet_text = $item->content;
    $comment_type = get_option('topsy_comment_type');
    if ($comment_type == 'comment') {
        $comment_type = '';
    }
    if (get_option('topsy_linkify_atuser') == 'on') {
        $tweet_text = topsy_linkify_atuser($tweet_text);
    }
    if (get_option('topsy_linkify_hashtag') == 'on') {
        $tweet_text = topsy_linkify_hashtag($tweet_text);
    }
    
    $comment_data = array(
        'comment_post_ID' => $post->ID,
        'comment_author' => $tweeter_realname,
        'comment_author_url' => $tweet_url,
        'comment_date' => date('Y-m-d H:i:s', $item->date),
        'comment_type' => $comment_type,
        'comment_content' => $wpdb->escape("<span class=\"topsy_trackback_comment\"><span class=\"topsy_twitter_username\"><span class=\"topsy_trackback_content\">$tweet_text</span></span>"),
        'comment_agent' => "Topsy plugin for WordPress v$TOPSY_VERSION",
    );
    $comment_id = wp_insert_comment($comment_data);
}

function topsy_hook_delete_post($post_id) {
    topsy_send_autonotification($post_id, 1);
}
function topsy_hook_publish_post($post_id, $retry = 0) {
    if ($retry > 10) return;
    if (! $retry) {
        topsy_send_autonotification($post_id);
    }
    $post = get_post($post_id);
    $link = get_permalink($post);
    $title = $post->post_title;
    if (get_post_meta($post_id, '_topsy_long_url', true) != $link) {
        $short_url = topsy_shorten_url($link);
        if (substr($short_url, 0, 5) == 'Error') {
            wp_schedule_single_event(time() + 601, 'topsy_retry_shorten_url', array($post_id, $retry + 1));
        } else {
            update_post_meta($post_id, '_topsy_long_url', $link);
            update_post_meta($post_id, 'topsy_short_url', $short_url);
        }
    }
}
function topsy_hook_unpublish_post($new_status = false, $old_status = false, $post = false) {
    if ($old_status == 'publish' && $new_status != 'publish' && $post) {
        topsy_send_autonotification($post->ID, 1);
    }
}

function topsy_http_get($url, $prev = array()) {
    global $topsy_conn_timeout, $TOPSY_VERSION;
    if (preg_match("/^http:\/\/([-\w\.]+)(\/[\S]+)?/", $url, $match)) {
        $hostname = $match[1];
        $remote_path = count($match) > 2 ? $match[2] : '/';
    } else {
        return array('error' => "Invalid URL!");
    }
    $fp = fsockopen($hostname, 80, $errno, $errstr, $topsy_conn_timeout);
    if (! $fp) {
        return array('error' => $errstr);
    }
    fwrite($fp, "GET $remote_path HTTP/1.1\r\n");
    fwrite($fp, "Host: $hostname\r\n");
    fwrite($fp, "Accept: application/xml, text/*\r\n");
    fwrite($fp, "Accept-Charset: us-ascii, utf-8, iso-8859-1, unicode-1-1\r\n");
    fwrite($fp, "User-Agent: Topsy plugin for WordPress v$TOPSY_VERSION (PHP v" . phpversion() . ")\r\n");
    fwrite($fp, "Connection: close\r\n");
    fwrite($fp, "\r\n");
    if ($prev == 'nowait') {
        fclose($fp);
        return;
    }
    
    $raw_response = '';
    while (!feof($fp)) {
        $raw_response .= fgets($fp);
    }
    fclose($fp);
    
    list($raw_headers, $raw_body) = preg_split("/\r?\n\r?\n/", $raw_response, 2);
    foreach (preg_split("/\r?\n/", $raw_headers) as $hdr) {
        if (preg_match("/^HTTP\/\d\.\d (\d{3}) (.+)/", $hdr, $match)) {
            $status_code = $match[1];
            $status_text = trim($match[2]);
        } elseif (preg_match("/^([-\w]+):\s+(.+)/", $hdr, $match)) {
            $headers[$match[1]] = trim($match[2]);
        }
    }
    if (substr($status_code, 0, 1) == '3' && array_key_exists('Location', $headers)) {
        if (in_array($headers['Location'], $prev)) {
            return array('error' => "HTTP redirects have looped back to " . $headers['Location']);
        }
        array_push($prev, $url);
        return topsy_http_get($headers['Location'], $prev);
    }
    $trimmed_body = preg_replace("/^[0-9a-fA-F]{4}\r?\n/", '', $raw_body);
    return array(
        'status' => "$status_code $status_text",
        'status_code' => $status_code,
        'status_text' => $status_text,
        'headers' => $headers,
        'body' => $trimmed_body,
        'raw_body' => $raw_body,
        'raw_response' => $raw_response,
        'error' => null,
    );
}

function topsy_linkify_atuser($str) {
    return preg_replace("/@(\w{1,15})/", "<a href=\"http://topsy.com/twitter/$1\">@$1</a>", $str);
}
function topsy_linkify_hashtag($str) {
    return preg_replace("/#(\w{1,20})/", "<a href=\"http://topsy.com/s?q=%23$1\">#$1</a>", $str);
}

function topsy_retweet_big() {
    print topsy_generate_retweet_button('big');
}
function topsy_retweet_small() {
    print topsy_generate_retweet_button('small');
}

function topsy_self_url() {
    $proto = $_SERVER['HTTPS'] ? 'https' : 'http';
    return "$proto://" . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI'];
}

function topsy_send_autonotification($post_id, $darken = false) {
    if (get_option('topsy_autonotify_enabled') != 'on') return;
    $post = get_post($post_id);
    $link = get_permalink($post);
    $title = $post->post_title;
    if ($darken) {
        $darken = '&darken=1';
    }
    # Don't send requests for autosaves
    if (preg_match("/(autosave|revision)/", $link)) return;
    # Also, each save triggers the save_post hook *twice*, and the first
    # time doesn't have the right externally-accessible permalink URL.
    # Silently return on that request, too.
    $arr = debug_backtrace();
    foreach ($arr as $obj) {
        if (preg_match("/^_?wp_(put|save)_post_revision$/", $obj['function'])) return;
    }
    topsy_http_get("http://otter.topsy.com/scrape?title=" . urlencode($title) . "&url=" . urlencode($link) . $darken, 'nowait');
}

function topsy_settings_menu() {
    if ($_POST['topsy_save'])   { topsy_settings_save($_POST); }
    if ($_POST['topsy_clear'])  { topsy_settings_reset(); }
    if (isset($_POST['topsy_delete_comments'])) {
        $failed = array();
        $all_comments = topsy_get_plugin_comments();
        $total = count($all_comments);
        foreach ($all_comments as $comment_id) {
            if (! wp_delete_comment($comment_id)) {
                $failed []= $comment_id;
            }
        }
        if (count($failed)) {
            $message = "Out of $total trackback comments, I was unable to delete the $failed comments with the following ID numbers: " . implode('; ', $failed);
        } else {
            $plugin_file = plugin_basename(__FILE__);
            $deact_link = '<a href="' . wp_nonce_url('plugins.php?action=deactivate&amp;plugin=' . $plugin_file . '&amp;plugin_status=all&amp;paged=1', 'deactivate-plugin_' . $plugin_file) . '" title="' . __('Deactivate this plugin') . '">' . __('deactivate this plugin') . '</a>';
            $message = __("All $total trackback comments have been deleted. Note that if you don't $deact_link, the comments will return.", 'topsy');
        }
        print('
            <div id="message" class="updated fade">
                <p>'.$message.'</p>
            </div>
        ');
    }
    global $TOPSY_VERSION;
    $topsy_nick = get_option('topsy_retweet_username');
    if (! strlen($topsy_nick)) $topsy_nick = 'topsy';
    if (! function_exists('json_decode') || ! class_exists('Services_JSON')) {
        require_once(dirname(__FILE__) . DIRECTORY_SEPARATOR . 'JSON.php');
    }
    topsy_update_shortener_data();
    ?>
    <form action="<?php echo $_SERVER['REQUEST_URI']; ?>" method="post">
        <div class="wrap">
        <h2><?php _e('Topsy Plugin Setup','topsy') ?></h2>
        <p>You are using Topsy Plugin v<?php echo $TOPSY_VERSION ?>. You can check on Topsy's status at <a href="http://status.topsy.com/">status.topsy.com</a>.</p>

        <h3><?php _e('Retweet Button','topsy') ?></h3>
        <div style="margin-left: 2em;">
            <p>The Retweet Button displays the total number of tweets associated with your content. The button also has a link to retweet your content. You can <?php if (function_exists('add_shortcode')) { ?> include it anywhere in your posts with the tags <code>[topsy_retweet_small]</code> or <code>[topsy_retweet_big]</code>. You can also <?php } ?> add it to themes with <code>&lt;?php echo topsy_retweet_small() ?&gt;</code> or <code>&lt;?php echo topsy_retweet_big() ?&gt;</code>.</p><?php if (! function_exists('add_shortcode')) { ?>
            <p><strong>Note:</strong> Your WordPress version is only <?php print get_bloginfo('version'); ?>, which is a bit behind the times. If you upgrade your WordPress software to at least version 2.5, you can use shortcodes&nbsp;&mdash; such as <code>[topsy_retweet_small]</code>&nbsp;&mdash; to place the Retweet Button anywhere inside your posts. You'll also be much more secure against attacks if you upgrade to the latest version.</p>
            <?php } ?>
            <table class="form-table">
                <tr valign="top">
                    <th><?php _e('Display on page','topsy') ?></th>
                    <th><?php _e('Position Button...','topsy') ?></th>
                    <th><?php _e('Float?','topsy') ?></th>
                    <th><?php _e('Button style','topsy') ?></th>
                    <th><?php _e('Additional CSS','topsy') ?></th>
                </tr>
                <?php 
                    $pages = array(
                        'home' => 'Main Blog Page',
                        'page' => 'Static Content Page',
                        'post' => 'Individual Entry',
                        'category' => 'Category Listing',
                        'archive' => 'Archive Page',
                    );
                    foreach ($pages as $page => $label) { 
                        ?>
                        <tr valign="top">
                            <td>
                                <label><input type="checkbox" name="topsy_button_<?php print $page ?>_display" <?php print (get_option('topsy_button_'. $page . '_display') == 'on') ? ' checked="checked"' : ''; ?>> <?php _e($label, 'topsy') ?></label>
                            </td>
                            <td>
                                <select name="topsy_button_<?php print $page ?>_position">
                                    <option value="before" <?php print (get_option('topsy_button_' . $page . '_position') == 'before') ? ' selected="selected"' : ''; ?>/> <?php _e('Before Content','topsy') ?></option>
                                    <option value="after" <?php print (get_option('topsy_button_' . $page . '_position') == 'after') ? ' selected="selected"' : ''; ?>/> <?php _e('After Content','topsy') ?></option>
                                </select>
                            </td>
                            <td>
                                <select name="topsy_button_<?php print $page ?>_align">
                                    <option value="none" <?php print (get_option('topsy_button_' . $page . '_align') == 'none') ? ' selected="selected"' : ''; ?>/> <?php _e('None','topsy') ?></option>
                                    <option value="left" <?php print (get_option('topsy_button_' . $page . '_align') == 'left') ? ' selected="selected"' : ''; ?>/> <?php _e('Left','topsy') ?></option>
                                    <option value="right" <?php print (get_option('topsy_button_' . $page . '_align') == 'right') ? ' selected="selected"' : ''; ?>/> <?php _e('Right','topsy') ?></option>
                                </select>
                            </td>
                            <td>
                                <select name="topsy_button_<?php print $page ?>_style" class="topsy_button_size_selector">
                                <option value="big"   <?php print (get_option('topsy_button_' . $page . '_style') == 'big')     ? ' selected="selected"' : ''; ?>/> <?php _e('Big','topsy') ?></option>
                                <option value="small" <?php print (get_option('topsy_button_' . $page . '_style') == 'small')   ? ' selected="selected"' : ''; ?>/> <?php _e('Small','topsy') ?></option>
                                </select>
                            </td>
                            <td>
                                <input type="text" name="topsy_button_<?php print $page ?>_css" value="<?php print get_option('topsy_button_'.$page.'_css') ?>"/>
                            </td>
                        </tr>
                        <?php
                    }
                ?>
            </table>
            <br>
            <div id="topsy_ordering_controls" style="border: 1px dotted #666666; padding: 0 1em; display: none;">
                <p>
                    <strong>Small Button Appearance</strong>
                </p>
                <p>
                    When using a small button, you can adjust what order the three items (retweet count, retweet button, and Top*N badge) are displayed in. If you want your retweet bars to look more similar to other design elements on your site, you can reorder them using the drop-down control below.
                </p>
                <p id="topsy_example_button">
                    <div id="topsy_example_no_badge" style="float: left;"><script type="text/javascript" src="http://button.topsy.com/widget/retweet-small?url=http://labs.topsy.com/"></script></div> This shows an example of the items in the order you've chosen<br clear="left">
                    <br>
                    <div id="topsy_example_with_badge" style="float: left;"><script type="text/javascript" src="http://button.topsy.com/widget/retweet-small?url=http://lifehacker.com/5401954/programmer-101-teach-yourself-how-to-code"></script></div> And here's an example with a Top*100 badge
                </p>
                <p>
                    Use this drop-down control to select the order you want things in, from left to right.
                    <select name="topsy_smallbutton_order" id="topsy_smallbutton_order">
<?php
$opts = array(
    'count,retweet,badge',
    'count,badge,retweet',
    'retweet,count,badge',
    'retweet,badge,count',
    'badge,count,retweet',
    'badge,retweet,count',
);
$cur = get_option('topsy_smallbutton_order');
foreach ($opts as $val) {
    print "                        <option value=\"$val\"";
    if ($cur == $val) print " selected=\"selected\"";
    print ">";
    print preg_replace("/,/", ', ', ucfirst($val)) . "</option>\n";
}

?>
                    </select>
                </p>
                <script type="text/javascript" src="http://ajax.googleapis.com/ajax/libs/jquery/1.3.2/jquery.min.js"></script>
                <script type="text/javascript">
                    function topsyOrderControlDisplayer() {
                        var setting = 'none';
                        $('.topsy_button_size_selector').each(function(x, s){
                            if (s.options[s.selectedIndex].value == 'small') {
                                setting = 'block';
                                return false;
                            }
                        });
                        $("#topsy_ordering_controls").css("display", setting);
                    }
                    function topsyMockupRebuilder() {
                        var order = $('#topsy_smallbutton_order option:selected').val();
                        topsyMockupMakeOrder(order, $('#topsy_example_with_badge .topsy-sm'));
                        topsyMockupMakeOrder(order, $('#topsy_example_no_badge .topsy-sm'));
                    }

                    function topsyMockupMakeOrder(order, branch) {
                        branch = branch.get(0);
                        var count = $(branch).find('.topsy-sm-total').get(0);
                        var retweet = $(branch).find('.topsy-sm-retweet').get(0);
                        var badge = $(branch).find('.topsy-sm-badge').get(0);

                        $(order.split(',')).each(function(n, item) {
                            switch (item) {
                                case 'count':
                                    branch.appendChild(count);
                                    break;
                                case 'retweet':
                                    branch.appendChild(retweet);
                                    break;
                                case 'badge':
                                    if (badge !== undefined) branch.appendChild(badge);
                                    break;
                            }
                        });
                    }
                    $(document).ready(function() {
                        $('.topsy_button_size_selector').click(topsyOrderControlDisplayer);
                        $('#topsy_smallbutton_order').click(topsyMockupRebuilder);
                        topsyMockupRebuilder();
                        topsyOrderControlDisplayer();
                    });
                </script>
            </div>
            <p>
                <strong>Retweet Username</strong>
            </p>
            <p>
                When a user clicks the "Retweet" button on one of your blog entries, the text "RT @username" will be placed at the beginning of the tweet. What username do you want to use? (Leave blank to suppress this feature.)<br>
                <input type="text" name="topsy_retweet_username" value="<?php echo get_option('topsy_retweet_username');?>" />
            </p>
            <p>
                <strong>Add Button to RSS Feeds?</strong>
            </p>
            <p>
                <label><input type="checkbox" name="topsy_add_button_to_rss" id="topsy_add_button_to_rss" <?php print (get_option('topsy_add_button_to_rss') == 'on') ? 'checked="checked" ' : ''; ?>/> Add the Retweets Button to RSS feeds as well as pages on the web site</label>
            </p>
        </div>
        
        <h3><?php _e('Keep Topsy Updated', 'topsy') ?></h3>
        <div>
            <div>
                <input type="checkbox" name="topsy_autonotify_enabled" id="topsy_autonotify_enabled" <?php print (get_option('topsy_autonotify_enabled') == 'on') ? ' checked="checked"' : ''; ?> /> <label for="topsy_autonotify_enabled"><strong>Notify Topsy on post publication/deletion</strong></label>
            </div>
            <div style="margin-left: 2em;">
                <p>
                    Automatically notifies Topsy when you publish or unpublish a blog entry. This has two benefits: First, it ensures that the Retweet Button will create retweets with just the post title, not including your blog title. (For example: "RT @<?php echo $topsy_nick ?> My Latest Blog Post" instead of "RT @<?php echo $topsy_nick ?> My Latest Blog Post &mdash; <?php echo get_bloginfo('name') ?>".) <?php if (version_compare('2.3', get_bloginfo('version'), '<=')) { ?>Also, if you delete or unpublish a post, it will be immediately removed from Topsy's index.<?php } ?>
                </p>
                <p>
                    If you don't want Topsy to be updated when you publish or unpublish things, you can turn this off. However, your retweets will all have your blog title in them, as well as the article title.
                </p>
            </div>
        </div>
        

<?php
$shorteners = explode(',', get_option('topsy_urlshortener_list'));
foreach ($shorteners as $shortener) {
    $data = get_option('topsy_urlshortener_data_'. $shortener);
    if (! is_object($data)) $data = unserialize($data);
    $s_data[$shortener] = $data;
}
$active_shortener = get_option('topsy_url_shortener');
?>
<script type="text/javascript">
String.prototype.topsy_ucfirst = function(lowercase) {
    var str = this;
    if (lowercase) str = str.toLowerCase();
    return str.substr(0, 1).toUpperCase() + str.substr(1);
};
function topsy_require_text() {
    if (! $('#topsy_urlshortener_username').val()) {
        alert("You must enter your authentication data in the two fields under \"URL Shortener\".");
        return false;
    }
    if (! $('#topsy_urlshortener_authkey').val()) {
        alert("You must enter your authentication data in the two fields under \"URL Shortener\".");
        return false;
    }
}
function topsy_update_url_shorteners() {
    var s_data = <?php echo json_encode($s_data); ?>;
    var shortener = $('#topsy_url_shortener').val();
    $('#topsy_urlshortener_username_label').text(s_data[shortener]['service_username_label'].topsy_ucfirst());
    $('#topsy_urlshortener_authkey_label').text(s_data[shortener]['service_authkey_label'].topsy_ucfirst());
    if (s_data[shortener]['service_auth_reqd']) {
        $('#topsy_urlshortener_auth_verbiage').html("The " + s_data[shortener]['service_name'] + " service requires authentication to shorten URLs. You must enter your " + s_data[shortener]['service_username_label'] + " and " + s_data[shortener]['service_authkey_label'] + " below. If you are already logged into your " + s_data[shortener]['service_name'] + " account, you can find your " + s_data[shortener]['service_username_label'] + " and " + s_data[shortener]['service_authkey_label'] + " by going to <a href=\"" + s_data[shortener]['service_userinfo_link'] + "\">" + s_data[shortener]['service_userinfo_link'] + "</a>.");
        $('#save').click(topsy_require_text);
    } else {
        $('#topsy_urlshortener_auth_verbiage').html("If you wish, you can enter your " + s_data[shortener]['service_name'] + " " + s_data[shortener]['service_username_label'] + " and " + s_data[shortener]['service_authkey_label'] + " below, so that your short URLs will be associated with your account. (If you are already logged into your " + s_data[shortener]['service_name'] + " account, you can find your " + s_data[shortener]['service_username_label'] + " and " + s_data[shortener]['service_authkey_label'] + " by going to <a href=\"" + s_data[shortener]['service_userinfo_link'] + "\">" + s_data[shortener]['service_userinfo_link'] + "</a>.) However, this is optional and you can leave the fields blank if you want.");
        $('#save').unbind('click', topsy_require_text);
    }
    if (s_data[shortener]['service_auth_possible']) {
        $('#topsy_urlshortener_authdata').show();
    } else {
        $('#topsy_urlshortener_authdata').hide();
    }
}
$(document).ready(function() {
    topsy_update_url_shorteners();
    $('#topsy_url_shortener').change(topsy_update_url_shorteners);
});
</script>
        <h3><?php _e('URL Shortener', 'topsy') ?></h3>
        <div>
            <p>
                Topsy Widgets will automatically create short URLs for your posts. You can choose your preferred URL shortener here. Note that some shorteners require that you have a username and some sort of password or key, so you may have to enter that as well.
            </p>
            <p>
                Shortening Service: 
                <select name="topsy_url_shortener" id="topsy_url_shortener">
<?php
foreach ($s_data as $key => $data) {
    print "                    <option value=\"$key\"";
    if ($key == $active_shortener) print " selected=\"selected\"";
    print ">$data->service_name&nbsp;&nbsp;&nbsp;</option>\n";
}
?>
                </select>
            </p>
            <p id="topsy_urlshortener_authdata" style="display: none;">
                <span id="topsy_urlshortener_auth_verbiage">stuff</span><br>
                <span id="topsy_urlshortener_username_label">User Name</span>: <input type="text" name="topsy_urlshortener_username" id="topsy_urlshortener_username" value="<?php echo get_option('topsy_urlshortener_username'); ?>"><br>
                <span id="topsy_urlshortener_authkey_label">Password</span>: <input type="text" name="topsy_urlshortener_authkey" id="topsy_urlshortener_authkey" value="<?php echo get_option('topsy_urlshortener_authkey'); ?>">
            </p>
        </div>
        
        <h3><?php _e('Trackback Comments','topsy') ?></h3>
        <div>
            <div>
                <input type="checkbox" name="topsy_trackbacks_enabled" id="topsy_trackbacks_enabled" <?php print (get_option('topsy_trackbacks_enabled') == 'on') ? ' checked="checked"' : ''; ?> /> <label for="topsy_trackbacks_enabled"><strong>Enable trackback comments</strong></label>
            </div>
            <div style="margin-left: 2em;">
                This will add comments to your posts when people link to them in tweets. Deactivating this feature will not remove the comments (if any) that have already been created.
                <p>
                    <input type="radio" name="topsy_trackbacks_infonly" value="on" id="topsy_trackbacks_infonly_on"<?php print (get_option('topsy_trackbacks_infonly') == 'on') ? ' checked="checked"' : ''; ?> /><label for="topsy_trackbacks_infonly_on">&nbsp;Only create trackback comments from "influential" tweeters</label> <span style="font-size: 75%;">[<a href="http://labs.topsy.com/influence/">What's an "influential" person?</a>]</span><br>
                    <input type="radio" name="topsy_trackbacks_infonly" value="off" id="topsy_trackbacks_infonly_off"<?php print (get_option('topsy_trackbacks_infonly') == 'off') ? ' checked="checked"' : ''; ?> /><label for="topsy_trackbacks_infonly_off">&nbsp;Create trackback comments from anyone and everyone</label>
                </p>
                <p>
                    <strong>Comment Display Style</strong><br>
                    Some WordPress themes don't display trackbacks, or display them solely as an author name in a clickable hyperlink with no text. If your blog's theme does either of these, and you'd rather see full tweet texts, you can switch to the "comments" setting instead.
                </p>
                <p>
                    <input type="radio" name="topsy_comment_type" value="trackback" id="topsy_comment_type_trackback"<?php print (get_option('topsy_comment_type') == 'trackback') ? ' checked="checked"' : ''; ?> /><label for="topsy_comment_type_trackback">&nbsp;Display trackback comments as trackbacks</label><br>
                    <input type="radio" name="topsy_comment_type" value="comment" id="topsy_comment_type_comment"<?php print (get_option('topsy_comment_type') == 'comment') ? ' checked="checked"' : ''; ?> /><label for="topsy_comment_type_comment">&nbsp;Display trackback comments as comments</label>
                </p>
                <p>
                    <strong>Ignore tweets by the following Twitter usernames</strong><br>
                    (One username per line. You can put your own username here to keep from having trackbacks from your own tweets. You can also use this to block spammers. Just enter the username(s), with no @ signs.)<br>
                    <textarea name="topsy_ignore_list" id="topsy_ignore_list" style="width: 12em; height: 8em;"><?php echo str_replace('|', "\n", get_option('topsy_ignore_list')) ?></textarea>
                </p>
            </div>
        </div>
        <h3><?php _e('Delete Trackback Comments','topsy') ?></h3>
        <div style="margin-left: 2em;">
            <p>
                If your trackback comments have gotten messed up somehow, you can use this button to delete all Topsy-generated trackback comments on your blog. This will only affect comments created by the Topsy plugin. <strong>Please note</strong> that if you don't deactivate the plugin, the comments will be recreated again over the next day or two.
            </p>
            <p class="submit">
                <input type="submit" name="topsy_delete_comments" id="topsy_delete_comments" value="Delete Topsy-Created Trackback Comments" onclick="return confirm('Are you sure you want to delete all trackback comments created by the Topsy plugin?');" />
            </p>
        </div>
        <br/>
        <span class="submit">
            <input name="topsy_clear" id="reset" value="<?php _e('Reset Options', 'topsy') ?>" type="submit"/>
            <input name="topsy_save" id="save" value="<?php _e('Save Changes', 'topsy') ?>" type="submit"/>
        </span>
        </div>
    </form>
    
    <?php

}

function topsy_settings_reset() {
    add_option('topsy_trackbacks_enabled', 'on');
    add_option('topsy_trackbacks_infonly', 'off');
    add_option('topsy_linkify_hashtag', 'on');
    add_option('topsy_linkify_atuser', 'on');
    add_option('topsy_ignore_list', '');
    add_option('topsy_comment_type', 'trackback');
    $pages = array('home', 'page', 'post', 'category', 'archive');
    foreach ( $pages as $page ) {
        update_option('topsy_button_' . $page . '_display',     'on');
        update_option('topsy_button_' . $page . '_position',    'before');
        update_option('topsy_button_' . $page . '_align',       'right');
        update_option('topsy_button_' . $page . '_style',       'big');
        update_option('topsy_button_' . $page . '_css',         'margin-left: 0.75em');
    }
    add_option('topsy_add_button_to_rss', 'off');
    add_option('topsy_autonotify_enabled', 'on');
    add_option('topsy_smallbutton_order', $settings['topsy_smallbutton_order']);
    add_option('topsy_url_shortener', 'bitly');
    add_option('topsy_urlshortener_username', 'topsyplugin');
    add_option('topsy_urlshortener_authkey', 'R_0bb5fbe4ce1eb830679766704df41937');
    topsy_update_shortener_data();
}

function topsy_settings_save($settings) {
    update_option('topsy_trackbacks_enabled', ($settings['topsy_trackbacks_enabled'] == 'on') ? 'on' : 'off' );
    update_option('topsy_trackbacks_infonly', ($settings['topsy_trackbacks_infonly'] == 'on') ? 'on' : 'off' );
    update_option('topsy_linkify_atuser', ($settings['topsy_linkify_atuser'] == 'on') ? 'on' : 'off' );
    update_option('topsy_linkify_hashtag', ($settings['topsy_linkify_hashtag'] == 'on') ? 'on' : 'off' );
    update_option('topsy_comment_type', $settings['topsy_comment_type']);
    update_option('topsy_retweet_username', $settings['topsy_retweet_username']);
    update_option('topsy_ignore_list', implode('|', preg_split("/\s+/", trim($settings['topsy_ignore_list']))));
    $pages = array('home', 'page', 'post', 'category', 'archive');
    foreach ($pages as $page) {
        update_option('topsy_button_' . $page . '_display',     ($settings['topsy_button_' . $page . '_display'] == 'on') ? 'on' : 'off' );
        update_option('topsy_button_' . $page . '_position',     $settings['topsy_button_' . $page . '_position'] );
        update_option('topsy_button_' . $page . '_align',        $settings['topsy_button_' . $page . '_align'] );
        update_option('topsy_button_' . $page . '_style',        $settings['topsy_button_' . $page . '_style'] );
        update_option('topsy_button_' . $page . '_css',          $settings['topsy_button_' . $page . '_css'] );
    }
    update_option('topsy_add_button_to_rss', ($settings['topsy_add_button_to_rss'] == 'on') ? 'on' : 'off' );
    update_option('topsy_autonotify_enabled', ($settings['topsy_autonotify_enabled'] == 'on') ? 'on' : 'off' );
    update_option('topsy_smallbutton_order', $settings['topsy_smallbutton_order']);
    update_option('topsy_url_shortener', $settings['topsy_url_shortener']);
    update_option('topsy_urlshortener_username', $settings['topsy_urlshortener_username']);
    update_option('topsy_urlshortener_authkey', $settings['topsy_urlshortener_authkey']);
}

function topsy_shorten_url($long_url) {
    $shortener = get_option('topsy_url_shortener');
    $l_url = $long_url;
    
    # Need to globalize this var so topsy_eval_data/brackets can pick it up
    global $long_url;
    
    $long_url = $l_url;
    $s_data = get_option('topsy_urlshortener_data_'. $shortener);
    if (! is_object($s_data)) $s_data = unserialize($s_data);
    if ($s_data->http_method != 'get') {
        # We'll need to write code to perform POST requests if this ever happens.
        # For now, just bail out.
        return;
    }
    foreach ($s_data->http_reqd_vars as $r_var => $r_val) {
        $r_val = topsy_eval_data($r_val);
        $opts []= $r_var . '=' . urlencode($r_val);
    }
    foreach ($s_data->http_opt_vars as $r_var => $r_val) {
        $r_val = topsy_eval_data($r_val);
        if ($r_val) {
            $opts []= $r_var . '=' . urlencode($r_val);
        }
    }
    $all_opts = implode('&', $opts);
    
    $http_data = topsy_http_get($s_data->http_url . "?$all_opts");
    if (isset($http_data['error'])) return "Error: " . $http_data['error'];

    switch ($s_data->decode) {
        case 'json':
            if (! function_exists('json_decode') || ! class_exists('Services_JSON')) {
                require_once(dirname(__FILE__) . DIRECTORY_SEPARATOR . 'JSON.php');
            }
            # bit.ly sends the original URL as an object key, but the colon and
            # slashes make it impossible to dereference after it's been turned
            # into a PHP data structure. Just replace the URL with "ORIG_URL"
            # so we can actually access the damn thing.
            $preg_url = str_replace('/', '\/', preg_quote($long_url));
            $http_data['body'] = preg_replace('/"' . $preg_url . '"\s*:/', '"ORIG_URL" :', $http_data['body']);
            
            $web_data = json_decode($http_data['body']);
            break;
        case 'xml':
            # Warning: This will only work in PHP5+
            $web_data = new SimpleXMLElement($http_data['body']);
            break;
        default:
            # is.gd gives back HTML in "chunked" responses, as per RFC2616 section 3.6.1
            # (see http://tools.ietf.org/html/rfc2616.html#section-3.6.1).
            # Strip the leading and trailing numbers to get the real content.
            $web_data = preg_replace("/^\d+\s+/", '', preg_replace("/\s+\d+$/", '', trim($http_data['body'])));
    }
    
    if ($s_data->shorturl_key) {
        $s_key = '$web_data->' . $s_data->shorturl_key;
        eval("\$short_url = $s_key;");
    } else {
        $short_url = $web_data;
    }
    return $short_url;
}

function topsy_trackback_main() {
    if (get_option('topsy_trackbacks_enabled') != 'on') return;
    if (! is_single()) return;
    
    global $topsy_cache_time_tb, $post;
    $my_post_id = $post->ID;
    $my_url = topsy_self_url();
    if (time() - topsy_get_cache_time($my_url) < $topsy_cache_time_tb) {
        return;
    }
    if (topsy_get_ratelimit() < 5 && topsy_get_ratelimit('reset') > time()) {
        return;
    }
    
    # In WordPress versions < 2.7, get_comments() doesn't exist. Fall back
    # to get_approved_comments() instead.
    if (! function_exists('get_comments')) {
        function get_comments($arg) {
            if (substr($arg, 0, 8) == 'post_id=') {
                $arg = substr($arg, 8);
            }
            return get_approved_comments($arg);
        }
    }
    if (! function_exists('json_decode') || ! class_exists('Services_JSON')) {
        require_once(dirname(__FILE__) . DIRECTORY_SEPARATOR . 'JSON.php');
    }
    $http_data = topsy_http_get(topsy_trackback_url());
    if ($http_data['error']) {
        if ($topsy_debug) echo "Couldn't get trackback data; HTTP request failed with: " . $http_data['error'];
        return;
    }
    if ($http_data['status_code'] == 503) {
        # Do we need to do something special here? for now, we can just let the
        # default error response occur.
    }
    if ($http_data['status_code'] < 200 || $http_data['status_code'] > 299) {
        if ($topsy_debug) echo "Couldn't get trackback data; queried " . topsy_trackback_url() . " and got back a " . $http_data['status']  . " in response.";
        return;
    }
    $http_json = json_decode($http_data['body']);
    # There's some kind of race condition if we just loop over the 
    # JSON->response->list on its own; the topsy_comment_exists() function 
    # doesn't seem to pick up on the existence of the new comment fast 
    # enough after initial creation. Instead, we'll use hash key collisions 
    # to force uniqueness.
    $items = array();
    foreach ($http_json->response->list as $item) {
        $items[$item->permalink_url] = $item;
    }
    foreach ($items as $item) {
        topsy_handle_single_trackback($item, $http_json->response->topsy_trackback_url);
    }
    topsy_update_ratelimit($http_data['headers']['X-RateLimit-Limit'], $http_data['headers']['X-RateLimit-Remaining'], $http_data['headers']['X-RateLimit-Reset']);
    topsy_update_cache();
}

function topsy_trackback_url($my_url = '') {
    if (! $my_url) $my_url = topsy_self_url();
    $tb_url = 'http://otter.topsy.com/trackbacks.json?url=' . htmlentities(urlencode($my_url));
    if (get_option('topsy_trackbacks_infonly') == 'on') {
        $tb_url .= "&infonly=1";
    }
    return $tb_url;
}

function topsy_update_cache() {
    global $post;
    $now = time();
    add_post_meta($post->ID, '_topsy_cache_timestamp', $now, true) || update_post_meta($post->ID, '_topsy_cache_timestamp', $now);
}

function topsy_update_ratelimit($limit, $remaining, $reset) {
    update_option('topsy_rl_limit', $limit);
    update_option('topsy_rl_remaining', $remaining);
    update_option('topsy_rl_reset', $reset);
}

function topsy_update_shortener_data() {
    global $topsy_cache_time_udata;
    if (time() - intval(get_option('topsy_urlshortener_data_cachetime'), 10) < $topsy_cache_time_udata) return;
    $data_resource_url = 'http://cdn.topsy.com/asset/latest/widget/url_shorteners.json';
    $http_data = topsy_http_get($data_resource_url);
    if (isset($http_data['error'])) return;
    if (! function_exists('json_decode') || ! class_exists('Services_JSON')) {
        require_once(dirname(__FILE__) . DIRECTORY_SEPARATOR . 'JSON.php');
    }
    if ($http_data['status_code'] < 200 || $http_data['status_code'] > 299) {
        if ($topsy_debug) echo "Couldn't update URL shortener data; queried $data_resource_url and got back a " . $http_data['status']  . " in response.";
        return;
    }
    $http_json = json_decode($http_data['body']);
    foreach ($http_json as $key => $var) {
        $shortener_list []= $key;
        update_option('topsy_urlshortener_data_' . $key, serialize($var));
    }
    update_option('topsy_urlshortener_list', implode(',', $shortener_list));
    update_option('topsy_urlshortener_data_cachetime', time());
}




add_action('admin_menu', 'topsy_action_admin_menu');
add_action('deleted_post', 'topsy_hook_delete_post');
add_action('init', 'topsy_init');
add_action('transition_post_status', 'topsy_hook_unpublish_post');
add_action('wp', 'topsy_trackback_main');

add_action('publish_post', 'topsy_hook_publish_post');
add_action('publish_phone', 'topsy_hook_publish_post');
add_action('xmlrpc_publish_post', 'topsy_hook_publish_post');

add_action('topsy_retry_shorten_url', 'topsy_hook_publish_post');

add_filter('the_content', 'topsy_filter_the_content');
add_filter('the_content_rss', 'topsy_filter_the_content_rss');

if (function_exists('add_shortcode')) {
    add_shortcode('topsy_retweet_big', 'shortcode_topsy_retweet_big');
    add_shortcode('topsy_retweet_small', 'shortcode_topsy_retweet_small');
}
register_activation_hook( __FILE__, 'topsy_activation' );
register_deactivation_hook( __FILE__, 'topsy_deactivation' );

?>
